package @TARGET_PACKAGE@.tags;

import java.io.IOException;

import javax.servlet.jsp.tagext.TagSupport;
import javax.servlet.jsp.JspException;
import javax.servlet.jsp.PageContext;

import org.apache.turbine.util.RunData;
import org.apache.turbine.services.jsp.JspService;
import org.apache.turbine.om.security.User;

/**
 * UserInfoTag is a sample JSP tag handler that displays the full
 * name of the user that is currently logged in.
 */

public class UserInfoTag extends TagSupport
{
  /**
   * Process the StartTag event
   *
   * @exception JspException
   */

  public int doStartTag() throws JspException
  {

    // Get the Turbine "RunData" object that was stuffed into the Http request.

    RunData data = (RunData)pageContext.getAttribute(JspService.RUNDATA, PageContext.REQUEST_SCOPE);

    // If we have a RunData object, get the User object

    if (data != null)
    {
      User user = data.getUser();

      // Write out the user's full name (last name, first name)

      try
      {
        String fullName = user.getFirstName() + " " + user.getLastName();
        pageContext.getOut().print(fullName);
      }
      catch (IOException e)
      {
        throw new JspException("I/O Exception: " + e.getMessage());
      }
    }

    return SKIP_BODY;
  }
}
